package ru.dbotthepony.kommons.random

class ShishuaArrayOutput @JvmOverloads constructor(private val output: LongArray, var offset: Int = 0) : ShishuaOutput {
	init {
		require(output.size and (ShishuaEngine.OUTPUT_SIZE - 1) == 0) {
			"Provided array is now 128 byte aligned, ${output.size * 8} given."
		}

		require(offset >= 0) { "Negative array offset: $offset" }
	}

	override fun accept(values: LongArray) {
		System.arraycopy(values, 0, output, offset, values.size)
		offset += values.size
	}
}
