package ru.dbotthepony.kommons.test

import org.junit.jupiter.api.Assertions
import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.kommons.collect.iterateClearBits
import ru.dbotthepony.kommons.collect.iterateSetBits
import java.util.BitSet

object BitSetIteratorTest {
	@Test
	@DisplayName("Bit set iterator")
	fun test() {
		val bitSet = BitSet()
		bitSet[1] = true
		bitSet[4] = true
		bitSet[6] = true
		bitSet[7] = true
		bitSet[8] = true
		bitSet[10] = true
		bitSet[14] = true

		val expectedSet = intArrayOf(1, 4, 6, 7, 8, 10, 14)
		val expectedUnset = intArrayOf(0, 2, 3, 5, 9, 11, 12, 13)

		var i = 0

		for (bit in bitSet.iterateSetBits(15))
			Assertions.assertEquals(expectedSet[i++], bit)

		i = 0

		for (bit in bitSet.iterateClearBits(15))
			Assertions.assertEquals(expectedUnset[i++], bit)

		i = 1

		for (bit in bitSet.iterateSetBits(2, 15))
			Assertions.assertEquals(expectedSet[i++], bit)

		i = 2

		for (bit in bitSet.iterateClearBits(3, 15))
			Assertions.assertEquals(expectedUnset[i++], bit)

		Assertions.assertFalse(bitSet.iterateSetBits(15, 100).hasNext())
		Assertions.assertTrue(bitSet.iterateClearBits(1).hasNext())
		Assertions.assertFalse(bitSet.iterateClearBits(1, 2).hasNext())
	}
}
